#include "main.h"

/**
 * @brief Fonction de connexion
 * @param clientID: Tableau des identifiants client
 * @param isAdmin: Tableau des statuts Administrateur des clients
 * @param tlog: Taille logique des Tableaux
 * @return Est Admin ? (1 > Oui, 0 > Non, -1 > Quitter)
*/
int login(int clientID[], int clientPassword[], int isAdmin[], int tlog)
{
    int id, password, index, found, tentative=3;
    printf("Entrez votre identifiant: ");
    scanf("%d%*c", &id);
    while (id < 0)
    {
        printf("Erreur, l'identifiant doit être positif, entrez votre identifiant: ");
        scanf("%d%*c", &id);
    }
    index = searchTab(clientID, id, tlog, &found);
    while(found == 0)
    {
        printf("Erreur, l'identifiant n'existe pas, entrez votre identifiant: ");
        scanf("%d%*c", &id);
        if (id == 0)
        {
            return -1;
        }
        // Nombre de tentatives restantes
        tentative--;
        if (tentative == 0)
        {
            printf("Nombre de tentatives dépassé, retour au menu principal.\n");
            return -1;
        }
        printf("Il vous reste %d tentatives.\n", tentative);

        index = searchTab(clientID, id, tlog, &found);
    }

    printf("Entrez votre mot de passe: ");
    scanf("%d%*c", &password);
    while (password < 0)
    {
        printf("Erreur, le mot de passe doit être positif, entrez votre mot de passe: ");
        scanf("%d%*c", &password);
    }

    if (password == decrypt(clientPassword[index]))
    {
        if (isAdmin[index] == 1)
        {
            return 1;
        }
        else
        {
            return 0;
        }
    }
    else
    {
        printf("Erreur, le mot de passe est incorrect.\n");
        return -1;
    }
}

int signup(int clientID[], int clientPassword[], float cagnotte[], int suspended[], int isAdmin[], int *tlog)
{
    int id, password, index, found;
    printf("Entrez votre identifiant: ");
    scanf("%d%*c", &id);
    while (id < 0)
    {
        printf("Erreur, l'identifiant doit être positif, entrez votre identifiant: ");
        scanf("%d%*c", &id);
    }
    index = searchTab(clientID, id, *tlog, &found);
    while(found == 1)
    {
        printf("Erreur, l'identifiant existe déjà, entrez votre identifiant: ");
        scanf("%d%*c", &id);
        if (id == 0)
        {
            return -1;
        }
        index = searchTab(clientID, id, *tlog, &found);
    }

    printf("Entrez votre mot de passe: ");
    scanf("%d%*c", &password);
    while (password < 0)
    {
        printf("Erreur, le mot de passe doit être positif, entrez votre mot de passe: ");
        scanf("%d%*c", &password);
    }

    clientPassword[*tlog] = encrypt(password);

    clientID[*tlog] = id;
    cagnotte[*tlog] = 0;
    suspended[*tlog] = 0;
    isAdmin[*tlog] = 0;
    *tlog ++;
    return 0;
}