#include "main.h"

int displayMenu(void)
{
    /*
    Choix de l'action à réaliser

    +return: choix de l'action

    +var choice: choix de l'action
    */
    int choice;
    
    printf("\nTapez sur Entrée pour continuer...");
    //TODO Clear le buffer pour éviter les problèmes
    if (getchar() == '\n') // getchar() pour récupérer le caractère entré par l'utilisateur
    {
        printf("\e[1;1H\e[2J"); // Clear le terminal
    }

    printf("\n=================================\n");
    printf("          Menu Principal\n");
    printf("=================================\n");
    printf("1. \u25B6 Connexion\n");
    printf("2. \u25B6 Inscription\n");
    printf("3. \u25B6 Faire opposition\n");
    printf("4. \u274C Quitter\n");
    printf("9. \u26A0 Débug\n");
    printf("=================================\n");
    printf("Votre choix : ");
    scanf("%d%*c", &choice);

    printf("\e[1;1H\e[2J");

    return choice;
}

void global(void)
{
    /*
    Fonction global: Exécute les autres fonctions selon les choix de l'utilisateur

    +var tLogArticle: taille logique des tableaux contenant les données des articles
    +var tLogClient:  taille logique des tableaux contenant les données des clients
    +var choice:      choix de l'action à réaliser
    +var reference:   tableau des références des articles
    +var clientID:    tableau des identifiants des clients
    +var suspended:   tableau de l'état du compte des clients
    +var weight:      tableau du poids des articles
    +var volume:      tableau du volume des articles
    +var unitPrice:   tableau du prix unitaire des actions
    +var cagnotte:    tableau des cagnottes des clients
    */
    // Déclaration des variables
    int tLogArticle, tLogClient, choice, status, currentUser, clientPassword;
    int reference[tmaxArticles], clientID[tmaxClients], clientPassword[tmaxClients], suspended[tmaxClients], isAdmin[tmaxClients];
    float weight[tmaxArticles], volume[tmaxArticles], unitPrice[tmaxArticles], cagnotte[tmaxClients];
    // Chargement de toute les données
    chargeDonnees(&tLogArticle, &tLogClient, reference, weight, volume, unitPrice, clientID, clientPassword, cagnotte, suspended, isAdmin);
    // Affichage du menu
    choice = displayMenu();

    while (choice != 4)
    {
        switch (choice)
        {
            case 1:
                status = login(clientID, clientPassword, isAdmin, tLogClient);
                if(status == 1)
                {
                    //TODO > Menu Admin
                    //adminMenu();
                }
                else if(status == 0)
                {
                    //TODO > Menu Client
                    //clientMenu();
                }
                else
                {
                    printf("Connexion échouée.\nRetour au menu principal...\n");
                    sleep(3);
                }
                break;
            case 2:
                status = signup(clientID, clientPassword, cagnotte, suspended, isAdmin, &tLogClient);
                if(status == 0)
                {
                    printf("Inscription réussie.\nRetour au menu principal...\n");
                    sleep(3);
                }
                else
                {
                    printf("Inscription échouée.\nRetour au menu principal...\n");
                    sleep(3);
                }
                break;
            case 3:
                //TODO > Faire opposition
                //opposition();
                break;
            case 4:
                return;
            case 9:
                debugMenu(reference, weight, volume, unitPrice, clientID, cagnotte, suspended, isAdmin, tLogArticle, tLogClient);
                break;
            default:
                printf("Erreur, veuillez entrer un choix valide.\n");
                choice = displayMenu();
                break;
        }
        choice = displayMenu();
    }
}

int main(void)
{
    global();
    return 0;
}